# Class VulkanLayerProperties.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanLayerProperties.Builder

Enclosing class:
  `VulkanLayerProperties`

public static final class VulkanLayerProperties.Builder extends Object
Builds instances of type `VulkanLayerProperties`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanLayerProperties`
  `build()`
  Builds a new `VulkanLayerProperties`.
  `final VulkanLayerProperties.Builder`
  `from(VulkanLayerPropertiesType instance)`
  Fill a builder with attribute values from the provided `VulkanLayerPropertiesType` instance.
  `final VulkanLayerProperties.Builder`
  `setDescription(String description)`
  Initializes the value for the `description` attribute.
  `final VulkanLayerProperties.Builder`
  `setImplementationVersion(int implementationVersion)`
  Initializes the value for the `implementationVersion` attribute.
  `final VulkanLayerProperties.Builder`
  `setName(String name)`
  Initializes the value for the `name` attribute.
  `final VulkanLayerProperties.Builder`
  `setSpecificationVersion(int specificationVersion)`
  Initializes the value for the `specificationVersion` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanLayerProperties.Builder from(VulkanLayerPropertiesType instance)
    Fill a builder with attribute values from the provided `VulkanLayerPropertiesType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setName

    public final VulkanLayerProperties.Builder setName(String name)
    Initializes the value for the `name` attribute.
    Parameters:
      `name` - The value for name
    Returns:
      `this` builder for use in a chained invocation

  - ### setDescription

    public final VulkanLayerProperties.Builder setDescription(String description)
    Initializes the value for the `description` attribute.
    Parameters:
      `description` - The value for description
    Returns:
      `this` builder for use in a chained invocation

  - ### setSpecificationVersion

    public final VulkanLayerProperties.Builder setSpecificationVersion(int specificationVersion)
    Initializes the value for the `specificationVersion` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `specificationVersion`.

    Parameters:
      `specificationVersion` - The value for specificationVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### setImplementationVersion

    public final VulkanLayerProperties.Builder setImplementationVersion(int implementationVersion)
    Initializes the value for the `implementationVersion` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `implementationVersion`.

    Parameters:
      `implementationVersion` - The value for implementationVersion
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanLayerProperties build()
    Builds a new `VulkanLayerProperties`.
    Returns:
      An immutable instance of VulkanLayerProperties
    Throws:
      `IllegalStateException` - if any required attributes are missing